#ifndef SPACEPARTITION_H
#define SPACEPARTITION_H
#include "Ray.h"
#include "Hit.h"
#include "object.h"

 ////////////////////////////////////////////
//Spatial partitionning

namespace SpacePartition {

//Axis Aligned Bounding Box
class BBox{
public:
	qglviewer::Vec bbox[2];

	//Box intersection method
	bool boxIntersect(const Ray& r, Hit& hit) const;

};

//Triangle structure
class Triangle : public BBox {
public:
	qglviewer::Vec v[3];
	qglviewer::Vec t[3];
	qglviewer::Vec n[3];
	qglviewer::Vec c[3];

	qglviewer::Vec ts[3][2];

	bool triangleIntersect(const Ray& ray, Hit& hit) const;

	void compBBox();

};

//Box hierarchy class
class BoxNode : public BBox{

public:
	BoxNode(){
		subNodes[0]=subNodes[1]=NULL;
	}
	~BoxNode();

	BoxNode *subNodes[2];

	std::vector<Triangle*> triList;

	void draw(int l);

	//Recursive construction method
	void buildSubNodes(int cutAxe);
	bool treeIntersect(const Ray& r, Hit& hit) const;
	void compBBox();

};


};
#endif